// Code generated by cdpgen. DO NOT EDIT.

package serviceworker

import (
	"github.com/mafredri/cdp/protocol/target"
)

// Registration ServiceWorker registration.
type Registration struct {
	RegistrationID string `json:"registrationId"` // No description.
	ScopeURL       string `json:"scopeURL"`       // No description.
	IsDeleted      bool   `json:"isDeleted"`      // No description.
}

// VersionRunningStatus
type VersionRunningStatus string

// VersionRunningStatus as enums.
const (
	VersionRunningStatusNotSet   VersionRunningStatus = ""
	VersionRunningStatusStopped  VersionRunningStatus = "stopped"
	VersionRunningStatusStarting VersionRunningStatus = "starting"
	VersionRunningStatusRunning  VersionRunningStatus = "running"
	VersionRunningStatusStopping VersionRunningStatus = "stopping"
)

func (e VersionRunningStatus) Valid() bool {
	switch e {
	case "stopped", "starting", "running", "stopping":
		return true
	default:
		return false
	}
}

func (e VersionRunningStatus) String() string {
	return string(e)
}

// VersionStatus
type VersionStatus string

// VersionStatus as enums.
const (
	VersionStatusNotSet     VersionStatus = ""
	VersionStatusNew        VersionStatus = "new"
	VersionStatusInstalling VersionStatus = "installing"
	VersionStatusInstalled  VersionStatus = "installed"
	VersionStatusActivating VersionStatus = "activating"
	VersionStatusActivated  VersionStatus = "activated"
	VersionStatusRedundant  VersionStatus = "redundant"
)

func (e VersionStatus) Valid() bool {
	switch e {
	case "new", "installing", "installed", "activating", "activated", "redundant":
		return true
	default:
		return false
	}
}

func (e VersionStatus) String() string {
	return string(e)
}

// Version ServiceWorker version.
type Version struct {
	VersionID          string               `json:"versionId"`                    // No description.
	RegistrationID     string               `json:"registrationId"`               // No description.
	ScriptURL          string               `json:"scriptURL"`                    // No description.
	RunningStatus      VersionRunningStatus `json:"runningStatus"`                // No description.
	Status             VersionStatus        `json:"status"`                       // No description.
	ScriptLastModified *float64             `json:"scriptLastModified,omitempty"` // The Last-Modified header value of the main script.
	ScriptResponseTime *float64             `json:"scriptResponseTime,omitempty"` // The time at which the response headers of the main script were received from the server. For cached script it is the last time the cache entry was validated.
	ControlledClients  []target.ID          `json:"controlledClients,omitempty"`  // No description.
	TargetID           *target.ID           `json:"targetId,omitempty"`           // No description.
}

// ErrorMessage ServiceWorker error message.
type ErrorMessage struct {
	ErrorMessage   string `json:"errorMessage"`   // No description.
	RegistrationID string `json:"registrationId"` // No description.
	VersionID      string `json:"versionId"`      // No description.
	SourceURL      string `json:"sourceURL"`      // No description.
	LineNumber     int    `json:"lineNumber"`     // No description.
	ColumnNumber   int    `json:"columnNumber"`   // No description.
}
